searchNodes=[{"doc":"A native ExKeyCDN REST API client in Elixir. Based on Braintree Elixir client: https://github.com/sorentwo/braintree-elixirFor general reference please see: https://www.keycdn.com/api","ref":"ExKeyCDN.html","title":"ExKeyCDN","type":"module"},{"doc":"Convenience function for retrieving ExKeyCDN specfic environment values, but will raise an exception if values are missing.Exampleiex&gt; ExKeyCDN.get_env(:random_value) ** (ExKeyCDN.ConfigError) missing config for :random_value iex&gt; ExKeyCDN.get_env(:random_value, &quot;random&quot;) &quot;random&quot; iex&gt; Application.put_env(:exkeycdn, :random_value, &quot;not-random&quot;) ...&gt; value = ExKeyCDN.get_env(:random_value) ...&gt; Application.delete_env(:exkeycdn, :random_value) ...&gt; value &quot;not-random&quot; iex&gt; System.put_env(&quot;RANDOM&quot;, &quot;not-random&quot;) ...&gt; Application.put_env(:exkeycdn, :system_value, {:system, &quot;RANDOM&quot;}) ...&gt; value = ExKeyCDN.get_env(:system_value) ...&gt; System.delete_env(&quot;RANDOM&quot;) ...&gt; value &quot;not-random&quot;","ref":"ExKeyCDN.html#get_env/2","title":"ExKeyCDN.get_env/2","type":"function"},{"doc":"Convenience function for setting ExKeyCDN application environment variables.Exampleiex&gt; ExKeyCDN.put_env(:thingy, &quot;thing&quot;) ...&gt; ExKeyCDN.get_env(:thingy) &quot;thing&quot;","ref":"ExKeyCDN.html#put_env/2","title":"ExKeyCDN.put_env/2","type":"function"},{"doc":"This module provides a use macro to help convert raw HTTP responses into structs.","ref":"ExKeyCDN.Construction.html","title":"ExKeyCDN.Construction","type":"module"},{"doc":"Convert a response into one or more typed structs.","ref":"ExKeyCDN.Construction.html#new/2","title":"ExKeyCDN.Construction.new/2","type":"function"},{"doc":"Client api for https://www.ExKeyCDN.com/api#reports-api","ref":"ExKeyCDN.CreditStatistic.html","title":"ExKeyCDN.CreditStatistic","type":"module"},{"doc":"Decoded JSON string","ref":"ExKeyCDN.Decoder.html","title":"ExKeyCDN.Decoder","type":"module"},{"doc":"","ref":"ExKeyCDN.Decoder.html#decode/1","title":"ExKeyCDN.Decoder.decode/1","type":"function"},{"doc":"A general purpose response wrapper that is built for any failed API response.See the following pages for details about the various responses:https://www.keycdn.com/api#errors","ref":"ExKeyCDN.ErrorResponse.html","title":"ExKeyCDN.ErrorResponse","type":"module"},{"doc":"","ref":"ExKeyCDN.ErrorResponse.html#new/1","title":"ExKeyCDN.ErrorResponse.new/1","type":"function"},{"doc":"","ref":"ExKeyCDN.ErrorResponse.html#t:t/0","title":"ExKeyCDN.ErrorResponse.t/0","type":"type"},{"doc":"Encodes map to application/x-www-form-urlencoded","ref":"ExKeyCDN.FormEncoder.html","title":"ExKeyCDN.FormEncoder","type":"module"},{"doc":"","ref":"ExKeyCDN.FormEncoder.html#encode/1","title":"ExKeyCDN.FormEncoder.encode/1","type":"function"},{"doc":"Base client for all server interaction, used by all endpoint specific modules.This request wrapper coordinates the remote server, headers, authorization and SSL options.Using ExKeyCDN.HTTP requires the presence of one config value:api_key - ExKeyCDN api keyValue must be set or a ExKeyCDN.ConfigError will be raised at runtime. All those config values support the {:system, &quot;VAR_NAME&quot;} as a value - in which case the value will be read from the system environment with System.get_env(&quot;VAR_NAME&quot;).","ref":"ExKeyCDN.HTTP.html","title":"ExKeyCDN.HTTP","type":"module"},{"doc":"","ref":"ExKeyCDN.HTTP.html#delete/1","title":"ExKeyCDN.HTTP.delete/1","type":"function"},{"doc":"","ref":"ExKeyCDN.HTTP.html#delete/2","title":"ExKeyCDN.HTTP.delete/2","type":"function"},{"doc":"","ref":"ExKeyCDN.HTTP.html#get/1","title":"ExKeyCDN.HTTP.get/1","type":"function"},{"doc":"","ref":"ExKeyCDN.HTTP.html#get/2","title":"ExKeyCDN.HTTP.get/2","type":"function"},{"doc":"","ref":"ExKeyCDN.HTTP.html#get_lazy_env/3","title":"ExKeyCDN.HTTP.get_lazy_env/3","type":"function"},{"doc":"","ref":"ExKeyCDN.HTTP.html#post/1","title":"ExKeyCDN.HTTP.post/1","type":"function"},{"doc":"","ref":"ExKeyCDN.HTTP.html#post/2","title":"ExKeyCDN.HTTP.post/2","type":"function"},{"doc":"","ref":"ExKeyCDN.HTTP.html#put/1","title":"ExKeyCDN.HTTP.put/1","type":"function"},{"doc":"","ref":"ExKeyCDN.HTTP.html#put/2","title":"ExKeyCDN.HTTP.put/2","type":"function"},{"doc":"Centralized request handling function. All convenience structs use this function to interact with the ExKeyCDN servers. This function can be used directly to supplement missing functionality.Exampledefmodule MyApp.ExKeyCDN do alias ExKeyCDN.HTTP def zones(params \\ %{}) do HTTP.request(:get, &quot;zones.json&quot;, params) end end","ref":"ExKeyCDN.HTTP.html#request/3","title":"ExKeyCDN.HTTP.request/3","type":"function"},{"doc":"","ref":"ExKeyCDN.HTTP.html#t:response/0","title":"ExKeyCDN.HTTP.response/0","type":"type"},{"doc":"HTTP Behaviour","ref":"ExKeyCDN.HTTPBehaviour.html","title":"ExKeyCDN.HTTPBehaviour","type":"behaviour"},{"doc":"Sends http request","ref":"ExKeyCDN.HTTPBehaviour.html#c:request/3","title":"ExKeyCDN.HTTPBehaviour.request/3","type":"callback"},{"doc":"Encodes map to application/json","ref":"ExKeyCDN.JsonEncoder.html","title":"ExKeyCDN.JsonEncoder","type":"module"},{"doc":"","ref":"ExKeyCDN.JsonEncoder.html#encode/1","title":"ExKeyCDN.JsonEncoder.encode/1","type":"function"},{"doc":"Client api for https://www.ExKeyCDN.com/api#reports-api","ref":"ExKeyCDN.Report.html","title":"ExKeyCDN.Report","type":"module"},{"doc":"Balance Stats","ref":"ExKeyCDN.Report.html#balance/0","title":"ExKeyCDN.Report.balance/0","type":"function"},{"doc":"Credit Stats","ref":"ExKeyCDN.Report.html#credit/1","title":"ExKeyCDN.Report.credit/1","type":"function"},{"doc":"Image Processing Stats","ref":"ExKeyCDN.Report.html#image_processing/1","title":"ExKeyCDN.Report.image_processing/1","type":"function"},{"doc":"Status Stats","ref":"ExKeyCDN.Report.html#status/1","title":"ExKeyCDN.Report.status/1","type":"function"},{"doc":"Storage Stats","ref":"ExKeyCDN.Report.html#storage/1","title":"ExKeyCDN.Report.storage/1","type":"function"},{"doc":"Traffic Stats","ref":"ExKeyCDN.Report.html#traffic/1","title":"ExKeyCDN.Report.traffic/1","type":"function"},{"doc":"Report Behaviour","ref":"ExKeyCDN.ReportBehaviour.html","title":"ExKeyCDN.ReportBehaviour","type":"behaviour"},{"doc":"Balance Stats","ref":"ExKeyCDN.ReportBehaviour.html#c:balance/0","title":"ExKeyCDN.ReportBehaviour.balance/0","type":"callback"},{"doc":"Credit Stats","ref":"ExKeyCDN.ReportBehaviour.html#c:credit/1","title":"ExKeyCDN.ReportBehaviour.credit/1","type":"callback"},{"doc":"Image Processing Stats","ref":"ExKeyCDN.ReportBehaviour.html#c:image_processing/1","title":"ExKeyCDN.ReportBehaviour.image_processing/1","type":"callback"},{"doc":"Status Stats","ref":"ExKeyCDN.ReportBehaviour.html#c:status/1","title":"ExKeyCDN.ReportBehaviour.status/1","type":"callback"},{"doc":"Storage Stats","ref":"ExKeyCDN.ReportBehaviour.html#c:storage/1","title":"ExKeyCDN.ReportBehaviour.storage/1","type":"callback"},{"doc":"Traffic Stats","ref":"ExKeyCDN.ReportBehaviour.html#c:traffic/1","title":"ExKeyCDN.ReportBehaviour.traffic/1","type":"callback"},{"doc":"Client api for https://www.ExKeyCDN.com/api#reports-api","ref":"ExKeyCDN.Statistic.html","title":"ExKeyCDN.Statistic","type":"module"},{"doc":"Client api for https://www.ExKeyCDN.com/api#reports-api","ref":"ExKeyCDN.StatusStatistic.html","title":"ExKeyCDN.StatusStatistic","type":"module"},{"doc":"General purpose utility functions.","ref":"ExKeyCDN.Util.html","title":"ExKeyCDN.Util","type":"module"},{"doc":"Recursively convert a map of string keys into a map with atom keys. Intended to prepare responses for conversion into structs. Note that it converts any string into an atom, whether it existed or not.For unknown maps with unknown keys this is potentially dangerous, but should be fine when used with known ExKeyCDN endpoints.Exampleiex&gt; ExKeyCDN.Util.atomize(%{&quot;a&quot; =&gt; 1, &quot;b&quot; =&gt; %{&quot;c&quot; =&gt; 2}}) %{a: 1, b: %{c: 2}}","ref":"ExKeyCDN.Util.html#atomize/1","title":"ExKeyCDN.Util.atomize/1","type":"function"},{"doc":"","ref":"ExKeyCDN.Util.html#get_limits/1","title":"ExKeyCDN.Util.get_limits/1","type":"function"},{"doc":"","ref":"ExKeyCDN.Util.html#http/0","title":"ExKeyCDN.Util.http/0","type":"function"},{"doc":"Converts underscored values to hyphenated strings.Examplesiex&gt; ExKeyCDN.Util.hyphenate(&quot;key_cdn&quot;) &quot;key-cdn&quot; iex&gt; ExKeyCDN.Util.hyphenate(:key_cdn) &quot;key-cdn&quot;","ref":"ExKeyCDN.Util.html#hyphenate/1","title":"ExKeyCDN.Util.hyphenate/1","type":"function"},{"doc":"","ref":"ExKeyCDN.Util.html#map_to_keywordlist/1","title":"ExKeyCDN.Util.map_to_keywordlist/1","type":"function"},{"doc":"","ref":"ExKeyCDN.Util.html#map_to_struct/3","title":"ExKeyCDN.Util.map_to_struct/3","type":"function"},{"doc":"","ref":"ExKeyCDN.Util.html#successfull?/1","title":"ExKeyCDN.Util.successfull?/1","type":"function"},{"doc":"Converts hyphenated values to underscore delimited strings.Examplesiex&gt; ExKeyCDN.Util.underscorize(&quot;key-cdn&quot;) &quot;key_cdn&quot; iex&gt; ExKeyCDN.Util.underscorize(:&quot;key-cdn&quot;) &quot;key_cdn&quot;","ref":"ExKeyCDN.Util.html#underscorize/1","title":"ExKeyCDN.Util.underscorize/1","type":"function"},{"doc":"Client api for https://www.ExKeyCDN.com/api#zones-api","ref":"ExKeyCDN.Zone.html","title":"ExKeyCDN.Zone","type":"module"},{"doc":"Add","ref":"ExKeyCDN.Zone.html#add/1","title":"ExKeyCDN.Zone.add/1","type":"function"},{"doc":"Delete","ref":"ExKeyCDN.Zone.html#delete/1","title":"ExKeyCDN.Zone.delete/1","type":"function"},{"doc":"Edit","ref":"ExKeyCDN.Zone.html#edit/2","title":"ExKeyCDN.Zone.edit/2","type":"function"},{"doc":"List Zones","ref":"ExKeyCDN.Zone.html#list/0","title":"ExKeyCDN.Zone.list/0","type":"function"},{"doc":"Purge Cache","ref":"ExKeyCDN.Zone.html#purge_cache/1","title":"ExKeyCDN.Zone.purge_cache/1","type":"function"},{"doc":"Purge URL","ref":"ExKeyCDN.Zone.html#purge_url/2","title":"ExKeyCDN.Zone.purge_url/2","type":"function"},{"doc":"View","ref":"ExKeyCDN.Zone.html#view/1","title":"ExKeyCDN.Zone.view/1","type":"function"},{"doc":"Client api for https://www.ExKeyCDN.com/api#zones-aliases-api","ref":"ExKeyCDN.ZoneAlias.html","title":"ExKeyCDN.ZoneAlias","type":"module"},{"doc":"Add","ref":"ExKeyCDN.ZoneAlias.html#add/1","title":"ExKeyCDN.ZoneAlias.add/1","type":"function"},{"doc":"Delete","ref":"ExKeyCDN.ZoneAlias.html#delete/1","title":"ExKeyCDN.ZoneAlias.delete/1","type":"function"},{"doc":"Edit","ref":"ExKeyCDN.ZoneAlias.html#edit/2","title":"ExKeyCDN.ZoneAlias.edit/2","type":"function"},{"doc":"List Zone Aliases","ref":"ExKeyCDN.ZoneAlias.html#list/0","title":"ExKeyCDN.ZoneAlias.list/0","type":"function"},{"doc":"Zone Aliases Behaviour","ref":"ExKeyCDN.ZoneAliasBehaviour.html","title":"ExKeyCDN.ZoneAliasBehaviour","type":"behaviour"},{"doc":"Add","ref":"ExKeyCDN.ZoneAliasBehaviour.html#c:add/1","title":"ExKeyCDN.ZoneAliasBehaviour.add/1","type":"callback"},{"doc":"Delete","ref":"ExKeyCDN.ZoneAliasBehaviour.html#c:delete/1","title":"ExKeyCDN.ZoneAliasBehaviour.delete/1","type":"callback"},{"doc":"Edit","ref":"ExKeyCDN.ZoneAliasBehaviour.html#c:edit/2","title":"ExKeyCDN.ZoneAliasBehaviour.edit/2","type":"callback"},{"doc":"List","ref":"ExKeyCDN.ZoneAliasBehaviour.html#c:list/0","title":"ExKeyCDN.ZoneAliasBehaviour.list/0","type":"callback"},{"doc":"Zone Behaviour","ref":"ExKeyCDN.ZoneBehaviour.html","title":"ExKeyCDN.ZoneBehaviour","type":"behaviour"},{"doc":"Add","ref":"ExKeyCDN.ZoneBehaviour.html#c:add/1","title":"ExKeyCDN.ZoneBehaviour.add/1","type":"callback"},{"doc":"Delete","ref":"ExKeyCDN.ZoneBehaviour.html#c:delete/1","title":"ExKeyCDN.ZoneBehaviour.delete/1","type":"callback"},{"doc":"Edit","ref":"ExKeyCDN.ZoneBehaviour.html#c:edit/2","title":"ExKeyCDN.ZoneBehaviour.edit/2","type":"callback"},{"doc":"List","ref":"ExKeyCDN.ZoneBehaviour.html#c:list/0","title":"ExKeyCDN.ZoneBehaviour.list/0","type":"callback"},{"doc":"Purge Cache","ref":"ExKeyCDN.ZoneBehaviour.html#c:purge_cache/1","title":"ExKeyCDN.ZoneBehaviour.purge_cache/1","type":"callback"},{"doc":"Purge URL","ref":"ExKeyCDN.ZoneBehaviour.html#c:purge_url/2","title":"ExKeyCDN.ZoneBehaviour.purge_url/2","type":"callback"},{"doc":"Returns zone based on id","ref":"ExKeyCDN.ZoneBehaviour.html#c:view/1","title":"ExKeyCDN.ZoneBehaviour.view/1","type":"callback"},{"doc":"Client api for https://www.ExKeyCDN.com/api#zones-referrers-api","ref":"ExKeyCDN.ZoneReferrer.html","title":"ExKeyCDN.ZoneReferrer","type":"module"},{"doc":"Add","ref":"ExKeyCDN.ZoneReferrer.html#add/1","title":"ExKeyCDN.ZoneReferrer.add/1","type":"function"},{"doc":"Delete","ref":"ExKeyCDN.ZoneReferrer.html#delete/1","title":"ExKeyCDN.ZoneReferrer.delete/1","type":"function"},{"doc":"Edit","ref":"ExKeyCDN.ZoneReferrer.html#edit/2","title":"ExKeyCDN.ZoneReferrer.edit/2","type":"function"},{"doc":"List Zone Referrers","ref":"ExKeyCDN.ZoneReferrer.html#list/0","title":"ExKeyCDN.ZoneReferrer.list/0","type":"function"},{"doc":"Zone Referrers Behaviour","ref":"ExKeyCDN.ZoneReferrerBehaviour.html","title":"ExKeyCDN.ZoneReferrerBehaviour","type":"behaviour"},{"doc":"Add","ref":"ExKeyCDN.ZoneReferrerBehaviour.html#c:add/1","title":"ExKeyCDN.ZoneReferrerBehaviour.add/1","type":"callback"},{"doc":"Delete","ref":"ExKeyCDN.ZoneReferrerBehaviour.html#c:delete/1","title":"ExKeyCDN.ZoneReferrerBehaviour.delete/1","type":"callback"},{"doc":"Edit","ref":"ExKeyCDN.ZoneReferrerBehaviour.html#c:edit/2","title":"ExKeyCDN.ZoneReferrerBehaviour.edit/2","type":"callback"},{"doc":"List","ref":"ExKeyCDN.ZoneReferrerBehaviour.html#c:list/0","title":"ExKeyCDN.ZoneReferrerBehaviour.list/0","type":"callback"},{"doc":"Raised at runtime when a config variable is missing.","ref":"ExKeyCDN.ConfigError.html","title":"ExKeyCDN.ConfigError","type":"exception"},{"doc":"Build a new ConfigError exception.","ref":"ExKeyCDN.ConfigError.html#exception/1","title":"ExKeyCDN.ConfigError.exception/1","type":"function"}]